#ifndef __DDCLIP_H__
#define __DDCLIP_H__

//---------------------------------------------------------------------------
//
//	File:			DDCLIP.H
//	Programmer:		Bob Provencher
//	Create Date:	4/27/96
//	Last Mod Date:	4/27/96
//	Description:	DirectDrawClipper wrapper
//
//	Copyright (c) 1996 Cog Interactive
//	All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef __COMMON_H__
#include "Common.h"
#endif

#ifndef __DDCOM_H__
#include "DDCom.h"
#endif

class DDClipper : public DDComObject< LPDIRECTDRAWCLIPPER >
{

friend class DDObject;

public:

	//
	//	initial creation, object just created
	//

	DDClipper( LPDIRECTDRAWCLIPPER p = 0 ) :
		DDComObject< LPDIRECTDRAWCLIPPER >( p )
	{
	}

	//
	//	copy from another object
	//

	DDClipper( const DDClipper& dd ) :
		DDComObject< LPDIRECTDRAWCLIPPER >( dd )
	{
		ASSERT_VALID( this );
	}

	DDClipper& operator = ( LPDIRECTDRAWCLIPPER p )
	{
		Copy( p );
		ASSERT_VALID( this );
		return *this;
	}

	DDClipper& operator = ( const DDClipper& dd )
	{
		Copy( dd );
		ASSERT_VALID( this );
		return *this;
	}

	#ifdef _DEBUG
	void AssertValid() const;
	#endif

};

#endif

