#ifndef __DDPAL_H__
#define __DDPAL_H__

//---------------------------------------------------------------------------
//
//	File:			DDPAL.H
//	Programmer:		Bob Provencher
//	Create Date:	4/27/96
//	Last Mod Date:	4/27/96
//	Description:	DirectDrawPalette object wrapper
//
//	Copyright (c) 1996 Cog Interactive
//	All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef __COMMON_H__
#include "Common.h"
#endif

#ifndef __DDCOM_H__
#include "DDCom.h"
#endif

class DDPalette : public DDComObject< LPDIRECTDRAWPALETTE >
{

friend class DDObject;

public:

	//
	//	initial creation, object just created
	//

	DDPalette( LPDIRECTDRAWPALETTE p = 0 ) :
		DDComObject< LPDIRECTDRAWPALETTE >( p )
	{
	}

	//
	//	copy from another object
	//

	DDPalette( const DDPalette& dd ) :
		DDComObject< LPDIRECTDRAWPALETTE >( dd )
	{
		ASSERT_VALID( this );
	}

	DDPalette& operator = ( const DDPalette& dd )
	{
		Copy( dd );
		ASSERT_VALID( this );
		return *this;
	}

	#ifdef _DEBUG
	void AssertValid() const;
	#endif

};

#endif

