#ifndef __DDSURF_H__
#define __DDSURF_H__

//---------------------------------------------------------------------------
//
//	File:			DDSURF.H
//	Programmer:		Bob Provencher
//	Create Date:	4/27/96
//	Last Mod Date:	4/27/96
//	Description:	DirectDraw object wrapper
//
//	Copyright (c) 1996 Cog Interactive
//	All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef __COMMON_H__
#include "Common.h"
#endif

#ifndef __DDCOM_H__
#include "DDCom.h"
#endif

class DDSurface : public DDComObject< LPDIRECTDRAWSURFACE >
{

friend class DDObject;

public:

	//
	//	initial creation, object just created
	//

	DDSurface( LPDIRECTDRAWSURFACE p = 0 ) :
		DDComObject< LPDIRECTDRAWSURFACE >( p )
	{
	}

	//
	//	copy from another object
	//

	DDSurface( const DDSurface& dd ) :
		DDComObject< LPDIRECTDRAWSURFACE >( dd )
	{
		ASSERT_VALID( this );
	}

	DDSurface& operator = ( LPDIRECTDRAWSURFACE p )
	{
		Copy( p );
		return *this;
	}

	DDSurface& operator = ( const DDSurface& dd )
	{
		Copy( dd );
		ASSERT_VALID( this );
		return *this;
	}

	#ifdef _DEBUG
	void AssertValid() const;
	#endif

};

#endif

