#ifndef __GEN_H__
#define __GEN_H__

//---------------------------------------------------------------------------
//
//  File:           GEN.H
//  Programmer:     Bob Provencher
//  Create Date:    11/27/94
//	Last Mod Date:	4/26/96
//  Description:    general purpose function prototypes
//
//  Copyright (c) 1994, 1995. Aesir Software, Inc.
//	Copyright (c) 1996 Cog Interactive
//  All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef __SYSINC_H__
#include "SysInc.h"
#endif

inline ClientToScreen( HWND hWnd, LPRECT rc )
{
	return ClientToScreen( hWnd, (LPPOINT)&rc->left ) &&
		   ClientToScreen( hWnd, (LPPOINT)&rc->right );
}

inline ScreenToClient( HWND hWnd, LPRECT rc )
{
	return ScreenToClient( hWnd, (LPPOINT)&rc->left ) &&
		   ScreenToClient( hWnd, (LPPOINT)&rc->right );
}

template <class T>
void constrain( T& x, T tmin, T tmax )
{
	x = max( tmin, min( x, tmax ) );
}

template <class T>
void swap( T& a, T& b )
{
	T temp = a;
	a = b;
	b = temp;
}

inline int Width( const RECT& rc )
{
	return rc.right - rc.left;
}

inline int Height( const RECT& rc )
{
	return rc.bottom - rc.top;
}

inline int Length( ifstream& str )
{
	long pos = str.tellg();
	str.seekg( 0, ios::end );
    long len = str.tellg();
    str.seekg( pos );
    return (int)len;
}

void Delay( DWORD delay );

inline ostream& operator << ( ostream& str, const RECT& rc )
{
	str << "( L " << rc.left  << ", T " << rc.top
    	<< ", R " << rc.right << ", B " << rc.bottom << " )";
    return str;
}

inline void itos( int i, string& s, int radix = 10 )
{
	char buffer[ 32 ];
    itoa( i, buffer, radix );
    s = buffer;
}
//
//	returns the (int)ciel( (float)dividend / (float)divisor );
//

int iceil( int dividend, int divisor );

#ifdef _MSC_VER
inline int random( int x )
{
	return rand() % x;
}
inline void randomize( void )
{
	srand( timeGetTime() );
}
#endif

#endif
