//---------------------------------------------------------------------------
//
//	File:			LOGIDPAL.CPP
//	Programmer: 	Bob Provencher
//	Create Date:	1/15/95
//	Last Mod Date:	4/26/96
//	Description:	LogIdPalette class implementation
//
//	Copyright (c) 1994, 1995. Aesir Software, Inc.
//	Copyright (c) 1996 Cog Interactive
//	All Rights Reserved.
//
//---------------------------------------------------------------------------

#include "SysInc.h"
#pragma hdrstop

#ifndef __COMMON_H__
#include "Common.h"
#endif

#ifndef __LOGIDPAL_H__
#include "LogIdPal.h"
#endif

BOOL LogIdPalette::MakeIdentity( const LogSystemPalette& syspal )
{
	BOOL fReturn;
	if ( LogSystemPalette::IsPaletteDevice() )
	{
		ResizeTo( syspal.NumEntries() );
		WORD stat =
			(WORD)( LogSystemPalette::GetUse() == SYSPAL_STATIC ? 20 : 2 );
		for ( int i = 0; i < stat / 2; i++ )
		{
			Entry( i ) = syspal[ i ];
			Entry( NumEntries() - i - 1 ) = syspal[ NumEntries() - i - 1 ];
		}
		SetEntryFlags( 0, (WORD)( stat / 2 ), 0 );
		SetEntryFlags( (WORD)( stat / 2 ), (WORD)( NumEntries() - stat ), PC_RESERVED );
		SetEntryFlags( (WORD)( NumEntries() - ( stat / 2 ) ), (WORD)( stat / 2 ), 0 );
		fReturn = TRUE;
	}
    else
    {
		ResizeTo( 256 );
        PALETTEENTRY pe0   = {   0,   0,   0, 0 };
        PALETTEENTRY pe255 = { 255, 255, 255, 0 };
        Entry( 0 )   = pe0;
        Entry( 255 ) = pe255;
        fReturn = TRUE;
    }
    return fReturn;
}


