#ifndef __SURF_H__
#define __SURF_H__

//---------------------------------------------------------------------------
//
//	File:			SURF.H
//	Programmer:		Bob Provencher
//	Create Date:	7/15/95
//	Last Mod Date:	4/26/96
//	Description:	
//
//	Copyright (c) 1995 Aesir Software, Inc.
//	Copyright (c) 1996 Cog Interactive
//	All Rights Reserved.
//
//---------------------------------------------------------------------------

#ifndef __COMMON_H__
#include "Common.h"
#endif

#ifndef __DDDIAG_H__
#include "DDDiag.h"
#endif

#ifndef __DDSURF_H__
#include "DDSurf.h"
#endif

#ifndef __DDPAL_H__
#include "DDPal.h"
#endif

#ifndef __DDCLIP_H__
#include "DDClip.h"
#endif

#ifndef __MAP_H__
#include "Map.h"
#endif

extern int  desired_fps;
extern int  numBackBuffs;
extern BOOL page_flip;

#define TEXT_WIDTH		160		// dword aligned
#define TEXT_HEIGHT		16

#define MAP_WIDTH		25
#define MAP_HEIGHT		25

extern DDSURFACEDESC		ddFlipSurfDesc;		// flip surface description
extern DDSurface			FlipSurface;		// flip surface
extern DDSURFACEDESC		ddPrimSurfDesc;		// primary surface description
extern DDSurface 			PrimarySurface;		// primary surface (the screen)
extern DDSURFACEDESC		ddOffSurfDesc;		// off-screen surface desc
extern DDSurface			OffSurface;			// off-screen surface

extern DDSURFACEDESC	  	ddTileSurfDesc;		// floor surface desc
extern DDSurface			TileSurface;		// floor surface

extern DDCOLORKEY			ddck;				// color key

extern DWORD start, end, attempts, frame, misses;

extern Map map;

const DWORD defTimeOut = 2000UL;

void CreateSurfaces( void );

void CleanUp();

void ComposeImage( void );
void ShowImage( void );
void CalcLayout( int cx, int cy );
void Tile( void );
void ComposeAndShowImage( void );

void RestoreIfLost( DDSurface& pDirectDrawSurface );

void CreatePrimarySurface( void );
void CreateBackSurface( void );
void CreateTileSurface( void );
void CreateTextSurface( void );

HRESULT CALLBACK EnumAttachedSurfacesCallback( LPDIRECTDRAWSURFACE lpDDSurface,
											   LPDDSURFACEDESC lpDDSurfDesc,
											   LPVOID );

#endif

